//
//  Helper.m
//
//  Created by Herbert Ptzl on Mon Feb 04 2002.
//  Copyright (c) 2002 H.Ptzl. 
//
//  This file is part of MultiTerm.
//
//  MultiTerm is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  MultiTerm is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with MultiTerm; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import "Helper.h"

#include "tview.h"
#include "tviewdef.h"

static const
TVColor _defaultColors[16] = {
        {   0,   0,   0, 0},
        { 255,   0,   0, 0},
        {   0, 255,   0, 0},
        { 127, 127,   0, 0},
        {   0,   0, 255, 0},
        { 127,   0, 127, 0},
        {   0, 127, 127, 0},
        { 127, 127, 127, 0},
        {  64,  64,  64, 0},
        { 255,  64,  64, 0},
        {  64, 255,  64, 0},
        { 255, 255,   0, 0},
        {  64,  64, 255, 0},
        { 255,   0, 255, 0},
        {   0, 255, 255, 0},
        { 255, 255, 255, 0}};
 

@implementation Helper

+ (TVTextOpts *)defaultTextOpts {
    static TVTextOpts _textOpts;
    static TVCharSet _charSet;
    static BOOL _firstTime = YES;
    
    if (_firstTime) {
        NSBitmapImageRep *_bitmapImageRep;

        _bitmapImageRep = [NSBitmapImageRep imageRepWithData:
                [NSData dataWithContentsOfFile:
                    [[NSBundle mainBundle]
                        pathForResource:@"TF_G0_6x11" 
                        ofType:@"tiff"]]];
        [_bitmapImageRep retain];
    
        TVS_BT(_charSet) = 0;	TVS_BL(_charSet) = 0;
        TVS_BR(_charSet) = 6;	TVS_BB(_charSet) = 11;
        TVS_CW(_charSet) = 6;	TVS_CH(_charSet) = 11;
        TVS_OF(_charSet) = 0;	TVS_CO(_charSet) = 127;

        _charSet.columns = 16;
        _charSet.rowstride = [_bitmapImageRep bytesPerRow];
        _charSet.data = [_bitmapImageRep bitmapData];
       
        TVO_SR(_textOpts,0) = &_charSet;
        
        _textOpts.colors = (TVColor *)_defaultColors;
        
        TVO_BT(_textOpts) = 1;	TVO_BL(_textOpts) = 1;
        TVO_BR(_textOpts) = 7;	TVO_BB(_textOpts) = 12;
        TVO_CW(_textOpts) = 7;	TVO_CH(_textOpts) = 12;

        _textOpts.mask.all = 0;					/* disable attribs */
        _textOpts.xor.detail.color.text = 7;

    }
    return &_textOpts;
}


@end
