//
//  TermDocument.m
//
//  Created by Herbert Ptzl on Sun Feb 03 2002.
//  Copyright (c) 2002 H.Ptzl. 
//
//  This file is part of MultiTerm.
//
//  MultiTerm is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  MultiTerm is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with MultiTerm; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import "MTDocument.h"
#import "MTShell.h"
#import "MTView.h"

#include "ptyhelper.h"

@implementation MTDocument

- (NSString *)windowNibName
{
    return @"MTDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
    [[aController window] makeKeyAndOrderFront:self];
    [[aController window] setResizeIncrements:NSMakeSize(7,12)];
    
    _shell = [[MTShell alloc] init];
//    [_shell setLaunchPath:@"/bin/bash"];
    [_shell setLaunchPath:[NSString stringWithCString:defaultShellPath()]];
    {
        TVSize ssize = {80,25};
        [_shell setScreenSize:ssize];
    }
    [_shell launch];
    [termView setShell:_shell];
}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
    // Insert code here to write your document from the given data.  You can also choose to override -fileWrapperRepresentationOfType: or -writeToFile:ofType: instead.
    return nil;
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    // Insert code here to read your document from the given data.  You can also choose to override -loadFileWrapperRepresentation:ofType: or -readFromFile:ofType: instead.
    return YES;
}



- (IBAction)action:(id)sender
{
    static NSRect origframe;
    static BOOL miniaturize = YES;
    
    if (miniaturize) {
        origframe = [[termView window] frame];
        [[termView window] setContentSize:NSMakeSize(140,124)];
    } else {
        [[termView window] setFrame:origframe display:YES];    
    }
    
    miniaturize = !miniaturize;
}


@end
