//
//  MTTask.h
//
//  Created by Herbert Ptzl on Mon Feb 04 2002.
//  Copyright (c) 2002 H.Ptzl. 
//
//  This file is part of MultiTerm.
//
//  MultiTerm is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  MultiTerm is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with MultiTerm; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import <Foundation/Foundation.h>


@interface MTTask : NSObject {
    @protected
    NSMutableDictionary *_dictionary;
    BOOL _hasExeced;
    BOOL _isRunning;
    int _suspendCount;
    int _terminationStatus;
    int _fileDesc[3];
    int _pid;
}

- (id)init;

// set parameters
// these methods can only be done before a launch

- (void)setLaunchPath:(NSString *)path;
- (void)setArguments:(NSArray *)arguments;
- (void)setEnvironment:(NSDictionary *)dict;
	// if not set, use current

- (void)setCurrentDirectoryPath:(NSString *)path;
	// if not set, use current

// get parameters
- (NSString *)launchPath;
- (NSArray *)arguments;
- (NSDictionary *)environment;
- (NSString *)currentDirectoryPath;

- (void)launch;

- (id)standardInput;
- (id)standardOutput;
- (id)standardError;

- (void)interrupt;
- (void)terminate;
- (void)kill;

- (BOOL)suspend;
- (BOOL)resume;

// status
- (int)processIdentifier; 
- (BOOL)isRunning;

- (int)terminationStatus;


@end
