//
//  TermView.h
//
//  Created by Herbert Ptzl on Sun Feb 03 2002.
//  Copyright (c) 2002 H.Ptzl. 
//
//  This file is part of MultiTerm.
//
//  MultiTerm is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  MultiTerm is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with MultiTerm; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


#import <AppKit/AppKit.h>

#import "MTShell.h"


@interface MTView : NSView {
    @protected
    MTShell *_shell;
    TVBitMap _bitmap;
    ALTextArea _viewport;
    TVTextOpts *_textopts;
}


- (NSSize)viewSizeForTextArea:(ALTextArea *)area;

- (ALTextArea *)textAreaForRect:(NSRect)aRect;

- (TVBitMap *)bitmap;
- (ALTextArea)viewport;

- (void)setShell:(MTShell *)aShell;

- (MTShell *)shell;


@end


@interface MTView (Adjustments)

- (void)adjustToFrame:(NSRect)frameRect;

@end


@interface MTView (Events)

- (BOOL)acceptsFirstResponder;

- (void)doCommandBySelector:(SEL)aSelector;
- (void)insertText:(NSString *)aString;

- (void)keyDown:(NSEvent *)theEvent;

@end
