/*
 *  atextdef.h
 *
 *  Created by Herbert Poetzl on Mon Feb 04 2002.
 *  Copyright (c) 2002 H.Poetzl. 
 *
 *  This file is part of MultiTerm.
 *
 *  MultiTerm is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MultiTerm is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MultiTerm; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef	_ATEXT_DEF_INCLUDE_
#define	_ATEXT_DEF_INCLUDE_


/*	Character Macros 	*/

#define	ALC_UNI(s)	(s).value.uni
#define	ALC_ASC(s)	(s).value.ascii

#define	ALC_ALL(s)	(s).attrib.all

#define	ALC_ABC(s)	(s).attrib.detail.color.back
#define	ALC_ATC(s)	(s).attrib.detail.color.text
#define	ALC_ACS(s)	(s).attrib.detail.charset
#define	ALC_AFL(s)	(s).attrib.detail

#define	ALC_SIZE	sizeof(ALTextChar)


/*	Area Macros 	*/

#define	MIN_CRV		-0xFFFFFF	
#define	MAX_CRV		0xFFFFFF
    /* needs better solution, fix me */

#define	ALA_SC(a)	(a).topleft.col
#define	ALA_EC(a)	(a).botright.col
#define	ALA_SR(a)	(a).topleft.row
#define	ALA_ER(a)	(a).botright.row

#define	ALA_AW(a)	(ALA_EC(a)-ALA_SC(a))
#define	ALA_AH(a)	(ALA_ER(a)-ALA_SR(a))

#define	ALA_C2O(a,c)	(ALA_AW(a)*(c).row + (c).col)
#define	ALA_O2C(a,o)	((o) % ALA_AW(a))	
#define	ALA_O2R(a,o)	((o) / ALA_AW(a))

#define	ALA_SIZE(a)	(ALA_AW(a)*ALA_AH(a))


#define	ALA_SET(a,sc,sr,ec,er)			\
        do {					\
            ALA_SC(a) = (sc); ALA_SR(a) = (sr);	\
            ALA_EC(a) = (ec); ALA_ER(a) = (er);	\
        } while (0)

#define	ALA_UNSET(a)				\
        ALA_SET(a, MAX_CRV, MAX_CRV, MIN_CRV, MIN_CRV)

#define	ALA_ISUNSET(a)	(			\
        (ALA_SC(a) == MAX_CRV) &&		\
        (ALA_SR(a) == MAX_CRV) &&		\
        (ALA_EC(a) == MIN_CRV) &&		\
        (ALA_ER(a) == MIN_CRV))            



#endif 	/* _ATEXT_DEF_INCLUDE_ */
