/*
 *  tstoredef.h
 *
 *  Created by Herbert Poetzl on Mon Feb 04 2002.
 *  Copyright (c) 2002 H.Poetzl. 
 *
 *  This file is part of MultiTerm.
 *
 *  MultiTerm is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MultiTerm is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MultiTerm; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef	_TSTORE_DEF_INCLUDE_
#define	_TSTORE_DEF_INCLUDE_

#include "atextdef.h"

/*	Screen Macros 	*/

#define	TSS_CC(s)	(s).cursor.col
#define	TSS_CR(s)	(s).cursor.row

#define	TSS_SC(s)	ALA_SC((s).area)
#define	TSS_SR(s)	ALA_SR((s).area)
#define	TSS_EC(s)	ALA_EC((s).area)
#define	TSS_ER(s)	ALA_ER((s).area)

#define	TSS_AW(s)	ALA_AW((s).area)
#define	TSS_AH(s)	ALA_AH((s).area)


/*	Local Screen Shortcuts	*/

#define	SWRAP		screen->flags.wrap
#define	SSCRL		screen->flags.scroll

#define	SCURC		screen->cursor.col
#define	SCURR		screen->cursor.row

#define	SNULC		screen->defaults.nullchar

#define	SLLAR		screen->hints.lastline		
#define	SLOFF		screen->offset		

//	#define	SSHINT(r)	screen->hints.scrollrows
#define	SDIRTY(a)	alExtendTextArea(&screen->hints.dirtyarea, (a))
#define	SACONF(a)	alConfineTextArea((a), &screen->area)


/*	Store Buffer Macros	*/

#define	TSB_LO(b,i)	(b).store[(i)].offset
#define	TSB_LC(b,i)	(b).store[(i)].count
#define	TSB_LD(b,i)	(b).store[(i)].data

/*	Circular Buffer Macros	*/

#define	CADD(a,b,m)	(((a)+(b))%(m))
#define	CSUB(a,b,m)	(((a)-(b))%(m))

#define	CIRA(i,b,c,m)	((((b)+(c))>(m))?			\
                        ((((b)<=(i)) && ((i)<(m))) || 		\
                         (((i)>=0) && ((i)<(((b)+(c))%(m))))):	\
                        (((b)<=(i)) && ((i)<((b)+(c)))))

#define	CI2L(b,i)	((((i)<((b).cindex % (b).maxcount))?	\
                        ((i)+(b).maxcount):((i)))-		\
                        ((b).cindex % (b).maxcount))
                        
#define	CL2I(b,l)	(((l)-(b).cindex) % (b).maxcount)


#endif 	/* _TSTORE_DEF_INCLUDE_ */
