/*
 *  tviewdef.h
 *
 *  Created by Herbert Poetzl on Mon Feb 04 2002.
 *  Copyright (c) 2002 H.Poetzl. 
 *
 *  This file is part of MultiTerm.
 *
 *  MultiTerm is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  MultiTerm is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with MultiTerm; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef	_TVIEW_DEF_INCLUDE_
#define	_TVIEW_DEF_INCLUDE_

/*	Coordinate Macros 	*/

#define	TVWidth(s)	(s).size.width
#define	TVHeight(s)	(s).size.height

#define	TVMinX(s)	(s).origin.x
#define	TVMinY(s)	(s).origin.y
#define	TVMaxX(s)	(TVMinX(s)+TVWidth(s))
#define	TVMaxY(s)	(TVMinY(s)+TVHeight(s))

/*	Bitmap Macros 		*/

#define	PIXSIZE		4

#define	TVB_CSIZE(s)	((s).width*(s).height*PIXSIZE)
#define	TVB_RSIZE(b)	(TVWidth(b)*PIXSIZE)
#define	TVB_SIZE(b)	(TVHeight(b)*((b).rowstride))

/*	Char Cell Macros 	*/

#define	TVC_CW(c)	(c).size.width
#define	TVC_CH(c)	(c).size.height

#define	TVC_BT(c)	(c).border.top
#define	TVC_BL(c)	(c).border.left
#define	TVC_BR(c)	(c).border.right
#define	TVC_BB(c)	(c).border.bottom


/*	Char Set Macros 	*/

#define	TVS_CW(s)	TVC_CW((s).cell)
#define	TVS_CH(s)	TVC_CH((s).cell)

#define	TVS_BL(s)	TVC_BL((s).cell)
#define	TVS_BR(s)	TVC_BR((s).cell)
#define	TVS_BT(s)	TVC_BT((s).cell)
#define	TVS_BB(s)	TVC_BB((s).cell)

#define	TVS_OF(s)	(s).range.offset
#define	TVS_CO(s)	(s).range.count


/*	Text Opts Macros 	*/

#define	TVO_CW(s)	TVC_CW((s).cell)
#define	TVO_CH(s)	TVC_CH((s).cell)

#define	TVO_BL(s)	TVC_BL((s).cell)
#define	TVO_BR(s)	TVC_BR((s).cell)
#define	TVO_BT(s)	TVC_BT((s).cell)
#define	TVO_BB(s)	TVC_BB((s).cell)

#define	TVO_SR(o,i)	(o).set[(i)].regular
#define	TVO_SB(o,i)	(o).set[(i)].bold
#define	TVO_SH(o,i)	(o).set[(i)].highlight
#define	TVO_SU(o,i)	(o).set[(i)].underline



#endif 	/* _TVIEW_DEF_INCLUDE_ */
